#include <stdio.h>
#include "lex.yy.h"
#include "parser.tab.h"

extern int yyparse (void);
extern int yydebug;
extern YYLTYPE yylloc;
/* This function is invoked by yyparse()
whenever it runs into an error. */
void yyerror(char const *message){
  printf("Syntax error at line %d:%d : ", yylloc.first_line, yylloc.first_column);
}

int main(int argc, char const *argv[]) {
  yyin = fopen(argv[1], "r");
  yydebug = 0;
  int result_code = yyparse();
  fclose(yyin);
  return result_code;
}
