%{
  /* This is the prologue section. This code goes
  on the top of the parser implementation file. */
  #include <stdio.h>
  extern int yyerror(char *message);
  extern int yylex(void);
  int fact_found = 0;
%}

%debug
%locations
%token DOT;
%token R_SEPARATOR;
%token INT_SYMBOL;
%token OP;
%token CP;
%token ATOM;
%token VARIABLE;
%token C;

%%

program : items interrogation items {
  if(!fact_found){
    printf("Syntax error: no fact found.\n");
    yynerrs++;
  }
  if(!yynerrs)
    printf("Program parsed successfully.\n");
  else
    printf("Program not parsed. Number of errors: %d.\n", yynerrs);
};

items : items item | item;

item : fact | rule;

fact : predicate DOT {fact_found = 1;};
      | error DOT {printf("Error in a fact.\n");};;

rule : predicate R_SEPARATOR predicate_list DOT
      | predicate R_SEPARATOR error DOT {printf("Error in a rule.\n");};;
      | error R_SEPARATOR predicate_list DOT {printf("Error in a rule.\n");};;

interrogation : INT_SYMBOL predicate_list DOT ;
              | INT_SYMBOL error DOT {printf("Error in an interrogation.\n");};

predicate_list : predicate | predicate_list C predicate |predicate_list C error {printf("Error in a predicate_list.\n");};;

predicate : ATOM OP arg_list CP | ATOM | ATOM OP error CP {printf("Error in a predicate.\n");};

arg_list : arg_list C argument | argument | arg_list C error {printf("Error in an argument list.\n");};;

argument : predicate | VARIABLE;
